#include <iostream>
#include <fstream>
#include <utility>
#include <tuple>
#include <initializer_list>
#include <array>
#include <deque>
#include <forward_list>
#include <list>
#include <vector>
#include <set>
#include <unordered_set>
#include <map>
#include <unordered_map>
#include <queue>
#include <stack>
#include "streamer.hpp"

template <class CharT, class Traits>
void test_ostream(std::basic_ostream<CharT, Traits>& out, const char* title){
    using namespace streamer;
    
    std::pair<int, double>       pair              {10, 100};
    std::tuple<int, int, double> tuple             {10, 10, 200.0};
    std::initializer_list<int>   initializer_list  {1, 2, 3, 4, 5};
    int                          native_array[]    {1, 2, 3, 4, 5};
    std::array<int, 5>           array            {{1, 2, 3, 4, 5}};
    std::deque<int>              deque             {1, 2, 3, 4, 5};
    std::forward_list<int>       forward_list      {1, 2, 3, 4, 5};
    std::list<int>               list              {1, 2, 3, 4, 5};
    std::vector<int>             vector            {1, 2, 3, 4, 5};
    std::set<int>                set               {1, 2, 3, 4, 5};
    std::multiset<int>           multiset          {1, 2, 3, 4, 5};
    std::unordered_set<int>      unordered_set     {1, 2, 3, 4, 5};
    std::unordered_multiset<int> unordered_multiset{1, 2, 3, 4, 5};
    std::map<int, double> map
        {{1, 1.0}, {2, 4.0}, {3, 9.0}, {4, 16.0}, {5, 25.0}};
    std::multimap<int, double> multimap
        {{1, 1.0}, {2, 4.0}, {3, 9.0}, {4, 16.0}, {5, 25.0}};
    std::unordered_map<int, double> unordered_map
        {{1, 1.0}, {2, 4.0}, {3, 9.0}, {4, 16.0}, {5, 25.0}};
    std::unordered_multimap<int, double> unordered_multimap
        {{1, 1.0}, {2, 4.0}, {3, 9.0}, {4, 16.0}, {5, 25.0}};
    std::queue<int> queue(deque);
    std::priority_queue<int> priority_queue(array.cbegin(), array.cend());
    std::stack<int> stack(deque);
    
    out << title << std::endl;
    out << "pair               = " << pair                << std::endl;
    out << "tuple              = " << tuple               << std::endl;
    out << "initializer_list   = " << initializer_list    << std::endl;
    out << "native_array       = " << native_array        << std::endl;
    out << "array              = " << array               << std::endl;
    out << "deque              = " << deque               << std::endl;
    out << "forward_list       = " << forward_list        << std::endl;
    out << "list               = " << list                << std::endl;
    out << "vector             = " << vector              << std::endl;
    out << "set                = " << set                 << std::endl;
    out << "multiset           = " << multiset            << std::endl;
    out << "unordered_set      = " << unordered_set       << std::endl;
    out << "unordered_multiset = " << unordered_multiset  << std::endl;
    out << "map                = " << map                 << std::endl;
    out << "multimap           = " << multimap            << std::endl;
    out << "unordered_map      = " << unordered_map       << std::endl;
    out << "unordered_multimap = " << unordered_multimap  << std::endl;
    out << "queue              = " << queue               << std::endl;
    out << "priority_queue     = " << priority_queue      << std::endl;
    out << "stack              = " << stack               << std::endl;
}

int main(){
    std::ofstream  ofstream("ofstream.txt");
    std::wofstream wofstream("wofstream.txt");
    test_ostream(std::cout,  "========== std::cout ==========" );
    test_ostream(std::wcout, "========== std::wcout ==========");
    test_ostream(ofstream,   "========== ofstream =========="  );
    test_ostream(wofstream,  "========== wofstream ==========" );
}